package cn.com.infosec.jce.provider;

import cn.com.infosec.crypto.params.AsymmetricKeyParameter;
import cn.com.infosec.crypto.params.DSAParameters;
import cn.com.infosec.crypto.params.DSAPrivateKeyParameters;
import cn.com.infosec.crypto.params.DSAPublicKeyParameters;
import java.math.BigInteger;
import java.security.InvalidKeyException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.interfaces.DSAPrivateKey;
import java.security.interfaces.DSAPublicKey;

public class DSAUtil {
   public static AsymmetricKeyParameter generatePublicKeyParameter(PublicKey key) {
      if (key instanceof DSAPublicKey) {
         DSAPublicKey key1 = (DSAPublicKey)key;
         BigInteger var10002 = key1.getY();
         BigInteger var10005 = key1.getParams().getP();
         DSAPublicKey var10006 = key1;
         BigInteger key2 = key1.getParams().getQ();
         return new DSAPublicKeyParameters(var10002, new DSAParameters(var10005, key2, var10006.getParams().getG()));
      } else {
         throw new InvalidKeyException("can't identify DSA public key: " + key.getClass().getName());
      }
   }

   public static AsymmetricKeyParameter generatePrivateKeyParameter(PrivateKey key) {
      if (key instanceof DSAPrivateKey) {
         DSAPrivateKey key1 = (DSAPrivateKey)key;
         BigInteger var10002 = key1.getX();
         BigInteger var10005 = key1.getParams().getP();
         DSAPrivateKey var10006 = key1;
         BigInteger key2 = key1.getParams().getQ();
         return new DSAPrivateKeyParameters(var10002, new DSAParameters(var10005, key2, var10006.getParams().getG()));
      } else {
         throw new InvalidKeyException("can't identify DSA private key.");
      }
   }
}
